import * as Babel from 'babel-core';
import { Asset, IInitOptions } from 'jgb-shared/lib';
import { FileType } from 'jgb-shared/lib/utils/preProcess';
export default class BabelAsset extends Asset {
    constructor(fileName: string, options: IInitOptions);
    babelConfig: any;
    babelFile: any;
    outputCode: string;
    waitResolveCollectDependencies: Array<Promise<any>>;
    isAstDirty: boolean;
    sourceMap: any;
    fileType: FileType;
    static outExt: string;
    getParserOptions(): Promise<any>;
    shouldInvalidate(cacheData: any): boolean;
    mightHaveDependencies(): boolean;
    parse(code: string): Promise<Babel.types.File>;
    collectDependencies(): Promise<void>;
    traverseFast(visitor: any): any;
    addDependency(name: string, opts?: any, node?: Babel.Node): Promise<void>;
    /**
     * 替换env环境变量
     */
    pretransform(): Promise<void>;
    traverse(visitor: any): void;
    transform(): Promise<void>;
    loadSourceMap(): Promise<void>;
    generate(): Promise<{
        code: string;
        map: any;
        ext: string;
    }>;
}
